Subject: bug#25: closed (Re: frame parameter menu-bar-lines changes height of frame)

From: [email-masked] (GNU bug Tracking System)
Date: Wed, 31 Dec 2014 18:37:03 +0000

Your bug report

#25: frame parameter menu-bar-lines changes height of frame

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
25: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=25
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: frame parameter menu-bar-lines changes height of frame
From: martin rudalics <[email-masked]>
To: [email-masked], [email-masked]
Date: Wed, 31 Dec 2014 19:36:36 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

 > > emacs -Q
 > >
 > > (make-frame '((width . 70)(height . 50)))
 > > (modify-frame-parameters (selected-frame) '((menu-bar-lines . 0)))
 > > (frame-parameters)
 > > (modify-frame-parameters (selected-frame) '((menu-bar-lines . 1)))
 > > (frame-parameters)
 > >
 > > Adding and removing a menu-bar line changes the visible height of the
 > > frame (incorrect), but it does not change the `height' frame
 > > parameter. The correct behavior is that observed for `tool-bar-lines':
 > > neither the visible frame height nor the `height' parameter is
 > > changed.
 >
 > Use (assq 'height (frame-parameters)) to see that the `height'
 > parameter does not change.

This can now be handled on trunk/master by adding 'menu-bar-lines' to
`frame-inhibit-implied-resize'.  Bug closed.

Thanks, martin

>From [email-masked] Fri Feb 29 01:09:19 2008
Resent-From: Jason Rumney <[email-masked]>
Resent-To: [email-masked]
Resent-Date: Fri, 29 Feb 2008 09:08:55 +0000
Resent-Message-Id: <[email-masked]>
Resent-User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.8.1.12) Gecko/20080213 Thunderbird/2.0.0.12
From: "Drew Adams" <[email-masked]>
To: "Bug-Gnu-Emacs" <[email-masked]>
Date: Mon, 23 Jul 2007 21:28:54 -0700
Importance: Normal
Subject: frame parameter menu-bar-lines changes height of frame
Sender: bug-gnu-emacs-bounces+jasonr=[email-masked]

Can we please revisit this now that the release is out?

> From: Drew Adams Sent: Saturday, June 10, 2006 8:57 AM
> To: Emacs-Pretest-Bug
> Subject: frame parameter menu-bar-lines changes height of frame
>
> emacs -Q
>
> (make-frame '((width . 70)(height . 50)))
> (modify-frame-parameters (selected-frame) '((menu-bar-lines . 0)))
> (frame-parameters)
> (modify-frame-parameters (selected-frame) '((menu-bar-lines . 1)))
> (frame-parameters)
>
> Adding and removing a menu-bar line changes the visible height of the
> frame (incorrect), but it does not change the `height' frame
> parameter. The correct behavior is that observed for `tool-bar-lines':
> neither the visible frame height nor the `height' parameter is
> changed.

Use (assq 'height (frame-parameters)) to see that the `height'
parameter does not change.

This was first reported 2.5 years ago. Here is the last bit
of discussion about it:

> From: Drew Adams Sent: Tuesday, June 13, 2006 11:59 AM
> Hi Eli,
> Thanks for your explanation. I understand better now.
>
> I'm fine with this not being fixed before the release. I would
> ask that it be fixed soon thereafter, if possible.
>
> If necessary, we can reopen the discussion of what the behavior
> should be. To me, it should be like the tool-bar behavior. If
> that's not possible in some contexts, then those contexts can be
> treated specially (do the best we can to determine menu-bar height etc.).
>
> Showing and hiding the menu-bar should not change the frame size
> whenever that is avoidable. There is no reason to reduce
> everything to the lowest common denominator, if that denominator
> is bugged behavior. If the bugged behavior is sometimes
> unavoidable, so be it, but let's not use it as the norm.
>
> Thx - Drew
>
> -----------------
>
>     > You've said that the reason to not fix this now or soon is
>     that fixing it
>     > would be difficult. Could you explain why menu-bar-lines is
>     different from
>     > tool-bar-lines in this respect?
>
>     Because, historically, the menu bar was just a line of text at the
>     upper edge of the frame (and still is, in the non-toolkit and tty
>     builds).  Tool bar was never an integral number of text lines.
>
>     > The latter works correctly. Couldn't the tool-bar-lines
>     > implementation (fix) apply also to menu-bar-lines?
>
>     Theoretically, yes.  But even the thread you cited (which started
>     about a different issue, and only touched the menu bar tangentially)
>     reveals that people are divided on what should be the right behavior.
>     There are also other complications, IIRC: the size of the menu bar may
>     not be known with some toolkits, so resizing the text area might be
>     tricky.
>
>     That is why I don't think we should try to fix this now.  The fact
>     that two years have passed (actually much more, since this issue was
>     discussed back when Gerd Moellmann was the head maintainer) is
>     unfortunate, but I think we will shoot in our foot if we add now as
>     yet additional complication in the display-related code.  I fear the
>     redisplay-dont-pause changes already complicated things enough, and
>     might prolong the pretest.  Emacs had this misfeature for a long time,
>     and complaints, if there were any, were minimal.  I think the fix can
>     wait a little longer.

In GNU Emacs 22.1.1 (i386-mingw-nt5.1.2600)
 of 2007-06-02 on RELEASE
Windowing system distributor `Microsoft Corp.', version 5.1.2600
configured using `configure --with-gcc (3.4) --cflags -Ic:/gnuwin32/include'

_______________________________________________
bug-gnu-emacs mailing list
[email-masked]
http://lists.gnu.org/mailman/listinfo/bug-gnu-emacs